//+------------------------------------------------------------------+
//|                                                  Value chart.mq4 |
//|                                                                  |
//| Helweg/Stendahl value charts                                     |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color3 Gold
#property indicator_color4 Red
#property indicator_color5 Lime
#property indicator_level1 -8.0
#property indicator_level2 -4.0
#property indicator_level4  4.0
#property indicator_level5  8.0
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    magicNumber      = 1;
extern int    numberOfBars     = 10;
extern bool   showLineChart    = false;
extern string _                = "Bars settings";
extern color  colorBarDown     = Red;
extern color  colorBarUp       = Green;
extern color  colorBarNeutral  = DimGray;
extern color  colorWickUp      = DimGray;
extern color  colorWickDown    = DimGray;
extern color  colorWickNeutral = DimGray;
extern int    widthWick        = 1;
extern int    widthBody        = 3;
extern string __               = "Line chart settings";
extern int    linePrice        = PRICE_CLOSE;
extern string ___              = "Averages settings";
extern int    ma1Period        = 12;
extern int    ma1Type          = MODE_EMA;
extern int    ma1Price         = PRICE_CLOSE;
extern int    ma2Period        = 26;
extern int    ma2Type          = MODE_EMA;
extern int    ma2Price         = PRICE_CLOSE;

//
//
//
//
//

string name;
int    window;
double hiBuffer[];
double loBuffer[];
double prBuffer[];
double paBuffer[];
double pbBuffer[];
double maBuffer[];
double mbBuffer[];
double vaBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,hiBuffer); SetIndexStyle(0,DRAW_NONE);
      SetIndexBuffer(1,loBuffer); SetIndexStyle(1,DRAW_NONE);
      SetIndexBuffer(2,prBuffer);
      SetIndexBuffer(3,maBuffer); SetIndexDrawBegin(3,ma1Period);
      SetIndexBuffer(4,mbBuffer); SetIndexDrawBegin(4,ma2Period);
         if (showLineChart)
               SetIndexStyle(2,DRAW_LINE);
         else  SetIndexStyle(2,DRAW_NONE);
         if (ma1Period>1)
               SetIndexStyle(3,DRAW_LINE);
         else  SetIndexStyle(3,DRAW_NONE);
         if (ma2Period>1)
               SetIndexStyle(4,DRAW_LINE);
         else  SetIndexStyle(4,DRAW_NONE);
      SetIndexBuffer(5,paBuffer);
      SetIndexBuffer(6,pbBuffer);
      SetIndexBuffer(7,vaBuffer);

   //
   //
   //
   //
   //
   
   numberOfBars = MathMax(numberOfBars,5);
   name = "Value chart ("+numberOfBars+","+magicNumber+")";   
      IndicatorShortName(name);
   return (0);
}

int deinit()
{
   string oName;
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      oName = ObjectName(i); if (StringFind(oName, name, 0) >= 0) ObjectDelete(oName);
   }
   return (0);
}

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit  = MathMin(Bars-counted_bars,Bars-2);
         window = WindowFind(name);

         if (counted_bars == 0)
         {
            for (i=0;i<ma1Period;i++) { paBuffer[Bars-i-1] = 0; maBuffer[Bars-i-1] = 0; }
            for (i=0;i<ma2Period;i++) { pbBuffer[Bars-i-1] = 0; mbBuffer[Bars-i-1] = 0; }
         }
   //
   //
   //
   //
   //

      int    nVarP = MathRound(numberOfBars/5.0);
      double nVar0,nVarA,nVarB,nVarC,nVarD,nVarE;
      double nVarR1,nVarR2,nVarR3,nVarR4,nVarR5;
      double nLRange;
      for (i=limit; i>=0; i--)
      {
         //
         //
         //
         //
         //
         
         if (numberOfBars<7)
         {            
               if (MathAbs(Close[i]-Close[i+1]) >= (High[i]-Low[i]))
                     nVarA = MathAbs(Close[i]-Close[i+1]);
               else  nVarA = (High[i]-Low[i]);
               vaBuffer[i] = nVarA;
               
               //
               //
               //
               //
               //
               
               double average=0;
               for (k=0; k<5; k++) average += vaBuffer[i];
                                   average /= 5;
               nLRange = average*0.2;
         }
         else
         {            
            nVarA = iHighesti(nVarP,i)-iLowesti(nVarP,i);
                        if  (nVarA == 0 && nVarP == 1)
                             nVarR1 = MathAbs(Close[i]-Close[i+nVarP]);
                        else nVarR1 = nVarA;                      
                     
            nVarB = iHighesti(nVarP,i+nVarP+1)-iLowesti(nVarP,i+nVarP);
                        if (nVarB == 0 && nVarP == 1)
                             nVarR2 = MathAbs(Close[i+nVarP]-Close[i+nVarP*2]);
                        else nVarR2 = nVarB;

            nVarC = iHighesti(nVarP,i+nVarP*2)-iLowesti(nVarP,i+nVarP*2);
                        if (nVarC == 0 && nVarP == 1)
                             nVarR3 = MathAbs(Close[i+nVarP*2]-Close[i+nVarP*3]);
                        else nVarR3 = nVarC;

            nVarD = iHighesti(nVarP,i+nVarP*3)-iLowesti(nVarP,i+nVarP*3);
                        if (nVarD == 0 && nVarP == 1)
                             nVarR4 = MathAbs(Close[i+nVarP*3]-Close[i+nVarP*4]);
                        else nVarR4 = nVarD;

            nVarE = iHighesti(nVarP,i+nVarP*4)-iLowesti(nVarP,i+nVarP*4);
                        if (nVarE == 0 && nVarP == 1)
                             nVarR5 = MathAbs(Close[i+nVarP*4]-Close[i+nVarP*5]);
                        else nVarR5 = nVarE;

            nLRange = ((nVarR1+nVarR2+nVarR3+nVarR4+nVarR5)/5.0)*0.2;
         }   	         

         //
         //
         //
         //
         //
               	         
	         if ( nLRange <= 0 ) continue;
            double hlAverage = 0;
               for (k=0; k<numberOfBars; k++) hlAverage += (High[i+k]+Low[i+k])/2.0;
                                              hlAverage /= numberOfBars;
            
               double nOpen  = (Open[i]  - hlAverage) / nLRange;
               double nHigh  = (High[i]  - hlAverage) / nLRange; hiBuffer[i] = nHigh;
	            double nLow   = (Low[i]   - hlAverage) / nLRange; loBuffer[i] = nLow;
	            double nClose = (Close[i] - hlAverage) / nLRange;	

            //
            //
            //
            //
            //	         

            if (showLineChart==false)
            {	         
               color  theBarColor  = colorBarNeutral;
               color  theWickColor = colorWickNeutral;
                  if (nClose<nOpen) { theBarColor = colorBarDown; theWickColor = colorWickDown; }
                  if (nClose>nOpen) { theBarColor = colorBarUp;   theWickColor = colorWickUp;   }
               
                  drawBar(Time[i],nHigh,nLow,nOpen,nClose,theBarColor,theWickColor);
            }
            else prBuffer[i] = getPrice(linePrice,nHigh,nLow,nOpen,nClose);
            if (ma1Period>1) paBuffer[i] = getPrice(ma1Price,nHigh,nLow,nOpen,nClose);
            if (ma2Period>1) pbBuffer[i] = getPrice(ma2Price,nHigh,nLow,nOpen,nClose);
      }
      
      if (ma1Period>1) for (i=limit; i>=0; i--) maBuffer[i] = iMAOnArray(paBuffer,0,ma1Period,0,ma1Type,i);
      if (ma2Period>1) for (i=limit; i>=0; i--) mbBuffer[i] = iMAOnArray(pbBuffer,0,ma2Period,0,ma2Type,i);
   
   //
   //
   //
   //
   //
   
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iHighesti(int period, int i)
{
   if (i>=Bars) return(0);
   double max  = High[i];
         for (int k=1;(i+k)<Bars && k<period; k++) if (max<High[i+k]) max = High[i+k];
   return(max);
}
double iLowesti(int period, int i)
{
   if (i>=Bars) return(0);
   double min  = Low[i];
         for (int k=1;(i+k)<Bars && k<period; k++) if (min>Low[i+k]) min = Low[i+k];
   return(min);
}

//
//
//
//
//

double getPrice(int priceType, double high, double low, double open, double close)
{
   double price = 0;
   switch (priceType)
   {
      case PRICE_CLOSE    : price = close; break;
      case PRICE_OPEN     : price = open;  break;
      case PRICE_HIGH     : price = high;  break;
      case PRICE_LOW      : price = low;   break;
      case PRICE_MEDIAN   : price = (high+low)/2.0; break;
      case PRICE_TYPICAL  : price = (high+low+close)/3.0; break;
      case PRICE_WEIGHTED : price = (high+low+close+close)/4.0;
   }               
   return(price);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void drawBar(int bTime, double prHigh, double prLow, double prOpen, double prClose, color barColor, color wickColor)
{
   string oName;
          oName = name+TimeToStr(bTime)+"w";
            if (ObjectFind(oName) < 0) ObjectCreate(oName,OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prHigh);
                 ObjectSet(oName, OBJPROP_PRICE2, prLow);
                 ObjectSet(oName, OBJPROP_COLOR, wickColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthWick);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
           
         oName = name+TimeToStr(bTime)+"b";
            if (ObjectFind(oName) < 0)ObjectCreate(oName,OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prOpen);
                 ObjectSet(oName, OBJPROP_PRICE2, prClose);
                 ObjectSet(oName, OBJPROP_COLOR, barColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthBody);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
}